<!DOCTYPE html>
<html>
  <head>
    <title>Google Calendar API Quickstart</title>
    <meta charset="utf-8" />
  </head>
  <body>
    <p>Google Calendar API Quickstart</p>

    <!--Add buttons to initiate auth sequence and sign out-->
    <button id="authorize_button" onclick="handleAuthClick()">Authorize</button>
    <button id="signout_button" onclick="handleSignoutClick()">Sign Out</button>
    <button id="event_button" onclick="handleEventCreateClick()">Event</button>

    <div id="content2">Content</div>


    <div id="content3">Content</div>


    <pre id="content" style="white-space: pre-wrap"></pre>

    <iframe src="https://calendar.google.com/calendar/embed?src=c_e6ceff457cf8388229897a005b8b117b985b3b8e3347f65e6c80035af056dc3e%40group.calendar.google.com&ctz=Europe%2FBudapest" style="border: 0" width="800" height="600" frameborder="0" scrolling="no"></iframe>

    <script type="text/javascript">
      /* exported gapiLoaded */
      /* exported gisLoaded */
      /* exported handleAuthClick */
      /* exported handleSignoutClick */

      // TODO(developer): Set to client ID and API key from the Developer Console
      const CLIENT_ID =
        "261593161993-pk9j8oggu9fop68484iaf1sqdoipsvd2.apps.googleusercontent.com";
      const API_KEY = "AIzaSyBl_OWLmbiFodkYk6-5vtB7zREemNc6TYM";

      // Discovery doc URL for APIs used by the quickstart
      const DISCOVERY_DOC =
        "https://www.googleapis.com/discovery/v1/apis/calendar/v3/rest";

      // Authorization scopes required by the API; multiple scopes can be
      // included, separated by spaces.
      const SCOPES = "https://www.googleapis.com/auth/calendar.readonly https://www.googleapis.com/auth/calendar";

      let tokenClient;
      let gapiInited = false;
      let gisInited = false;

      document.getElementById("authorize_button").style.visibility = "hidden";
      document.getElementById("signout_button").style.visibility = "hidden";

      const calendarId = "c_e6ceff457cf8388229897a005b8b117b985b3b8e3347f65e6c80035af056dc3e@group.calendar.google.com";

      /**
       * Callback after api.js is loaded.
       */
      function gapiLoaded() {
        gapi.load("client", initializeGapiClient);
      }

      /**
       * Callback after the API client is loaded. Loads the
       * discovery doc to initialize the API.
       */
      async function initializeGapiClient() {
        await gapi.client.init({
          apiKey: API_KEY,
          discoveryDocs: [DISCOVERY_DOC],
        });
        gapiInited = true;
        maybeEnableButtons();
      }

      /**
       * Callback after Google Identity Services are loaded.
       */
      function gisLoaded() {
        tokenClient = google.accounts.oauth2.initTokenClient({
          client_id: CLIENT_ID,
          scope: SCOPES,
          callback: "", // defined later
        });
        gisInited = true;
        maybeEnableButtons();
      }

      /**
       * Enables user interaction after all libraries are loaded.
       */
      function maybeEnableButtons() {
        if (gapiInited && gisInited) {
          document.getElementById("authorize_button").style.visibility =
            "visible";
        }
      }

      /**
       *  Sign in the user upon button click.
       */
      function handleAuthClick() {
        tokenClient.callback = async (resp) => {
          if (resp.error !== undefined) {
            throw resp;
          }
          document.getElementById("signout_button").style.visibility =
            "visible";
          document.getElementById("authorize_button").innerText = "Refresh";
          await listUpcomingEvents();
        };

        if (gapi.client.getToken() === null) {
          // Prompt the user to select a Google Account and ask for consent to share their data
          // when establishing a new session.
          tokenClient.requestAccessToken({ prompt: "consent" });
        } else {
          // Skip display of account chooser and consent dialog for an existing session.
          tokenClient.requestAccessToken({ prompt: "" });
        }
      }

      /**
       *  Sign out the user upon button click.
       */
      function handleSignoutClick() {
        const token = gapi.client.getToken();
        if (token !== null) {
          google.accounts.oauth2.revoke(token.access_token);
          gapi.client.setToken("");
          document.getElementById("content").innerText = "";
          document.getElementById("authorize_button").innerText = "Authorize";
          document.getElementById("signout_button").style.visibility = "hidden";
        }
      }

      /**
       * Print the summary and start datetime/date of the next ten events in
       * the authorized user's calendar. If no events are found an
       * appropriate message is printed.
       */
      async function listUpcomingEvents() {
        let response;
        try {
          const request = {
            calendarId: calendarId,
            timeMin: new Date().toISOString(),
            showDeleted: false,
            singleEvents: true,
            maxResults: 10,
            orderBy: "startTime",
          };
          response = await gapi.client.calendar.events.list(request);
        } catch (err) {
          document.getElementById("content").innerText = err.message;
          return;
        }

        const events = response.result.items;
        if (!events || events.length == 0) {
          document.getElementById("content").innerText = "No events found.";
          return;
        }
        // Flatten to string to display
        const output = events.reduce(
          (str, event) =>
            `${str}${event.summary} (${
              event.start.dateTime || event.start.date
            })\n`,
          "Events:\n"
        );
        document.getElementById("content").innerText = output;
      }

      async function handleEventCreateClick() {
        // Refer to the JavaScript quickstart on how to setup the environment:
        // https://developers.google.com/calendar/quickstart/js
        // Change the scope to 'https://www.googleapis.com/auth/calendar' and delete any
        // stored credentials.

        const start = new Date();
        const end = new Date(
          start.getFullYear(),
          start.getMonth(),
          start.getDate(),
          start.getHours() + 1
        );

        const event = {
          summary: "Google I/O 2015",
          location: "800 Howard St., San Francisco, CA 94103",
          description:
            "A chance to hear more about Google's developer products.",
          start: {
            dateTime: start.toISOString(),
            timeZone: "America/Los_Angeles",
          },
          end: {
            dateTime: end.toISOString(),
            timeZone: "America/Los_Angeles",
          },
          recurrence: ["RRULE:FREQ=DAILY;COUNT=2"],
          attendees: [
            { email: "laszlo.hegedus@cherubits.hu" },
            { email: "heglas11@gmail.com" },
          ],
          reminders: {
            useDefault: false,
            overrides: [
              { method: "email", minutes: 24 * 60 },
              { method: "popup", minutes: 10 },
            ],
          },
        };

        const request = gapi.client.calendar.events.insert({
          calendarId: calendarId,
          resource: event,
        });

        request.execute(function (event) {
          document.getElementById("content3").innerText = event.htmlLink;

          const eventPatch = {
            conferenceData: {
              createRequest: { requestId: "7qxalsvy0e" },
            },
          };

          gapi.client.calendar.events
            .patch({
              calendarId: calendarId,
              eventId: event.id,
              resource: eventPatch,
              sendNotifications: true,
              conferenceDataVersion: 1,
            })
            .execute(function (event) {
              console.log("Conference created for event: %s", event.htmlLink);
              const solution = event.conferenceData.conferenceSolution;
              const entryPoints = event.conferenceData.entryPoints;
              console.log(`Conference`, event.conferenceData)
              const content = document.getElementById("content2");
              const text = document.createTextNode("Join " + solution.name);
              const icon = document.createElement("img");
              icon.src = solution.iconUri;
              icon.height = "32px";
              icon.width = "32px";
              
              const link = document.createElement("a");
              link.appendChild(text);
              link.appendChild(icon);

              link.href = entryPoints[0].uri;

              content.appendChild(link);
            });

          
        });

      }
    </script>
    <script
      async
      defer
      src="https://apis.google.com/js/api.js"
      onload="gapiLoaded()"
    ></script>
    <script
      async
      defer
      src="https://accounts.google.com/gsi/client"
      onload="gisLoaded()"
    ></script>
  </body>
</html>
